﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Game.BoomerManUI
{
   public class Boom:Button
    {
        public int Len = 40;
        Image img = Image.FromFile(AppDomain.CurrentDomain.BaseDirectory + "Resource\\boom.png");
        public Boom(int x,int y)
        {
            BomPosPt = new Point(x, y);
            Enabled = false;
            //this.BackColor = Color.Black;
            this.Location = new Point(x, y);
            this.Width = 40;
            this.Height = 40;
            Len = 80;

            Bitmap map = new Bitmap(Width, Height);

            readTimer = new Timer();

            readTimer.Tick += ReadTimer_Tick;
            readTimer.Interval = 700;
            readTimer.Start();
        }
        public Point BomPosPt;
        public event Action<Boom> boomBOOMEvent;

        private void ReadTimer_Tick(object sender, EventArgs e)
        {
            times--;

            if (times <= 0)
            {
                readTimer.Stop();

                this.boomBOOMEvent?.Invoke(this);
               
            }
        }

        public int times = 3;

        public Timer readTimer = null;

        protected override void OnPaint(PaintEventArgs pevent)
        {
            base.OnPaint(pevent);
            pevent.Graphics.Clear(Control.DefaultBackColor);
            pevent.Graphics.DrawImage(img, new Rectangle(10, 0, Width, Height), new Rectangle(15, 20, img.Width, img.Height), GraphicsUnit.Pixel);
        }

        public List<BoomMonstor> KilledMonstor(List<Point> list, List<BoomMonstor> lstMonstor)
        {
            List<BoomMonstor> lst = new List<BoomMonstor>();

            if (lstMonstor != null && lstMonstor.Count > 0)
            {
                foreach (var item in lstMonstor)
                {
                    bool isKill = item.IsKillByBoom(list,this);

                    if (isKill)
                    {
                        item.Stop();
                        lst.Add(item);
                    }

                }
            }
            return lst;

        }

    }
}
