﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Game.BoomerManUI
{
    public class BoomMonstor : Button
    {


        Timer MoveTimer = null;
        List<Point> lstWalk = null;
        Point Pospt = default;
        Point MoveingPt = default;
        int direction = 0;
        List<Point> ListAll = new List<Point>();
        List<Point> ListHas = new List<Point>();
        bool isMoved = false;
        public event Action EventMoved;
        Graphics g = null;
        Image img = Image.FromFile(AppDomain.CurrentDomain.BaseDirectory + "Resource\\monster.png");
        int imgX = 10, imgY =17;
        public BoomMonstor(List<Point> lstWalkPt, Point playerPt)
        {
           
            lstWalk = lstWalkPt;
            Enabled = false;
            this.Width = 40;
            this.Height = 40;
            this.BackColor = Color.Transparent;
           
           
           
            this.InitalPos(playerPt);
            this.Name = "BoomMonstor_" + Pospt.X + "_" + Pospt.Y;
            MoveTimer = new Timer();
            
            MoveTimer.Tick += MoveTimer_Tick;
            MoveTimer.Interval = 400;
            MoveTimer.Start();
        }

        private void DrawImage(Graphics g1)
        {
            g1.Clear(Control.DefaultBackColor);
            g1.DrawImage(img, new Rectangle(5, 0, Width, Height), new Rectangle(imgX, imgY, Width, Height), GraphicsUnit.Pixel);


        }
        protected override void OnPaint(PaintEventArgs pevent)
        {
           
           g = pevent.Graphics;
          
            base.OnPaint(pevent);
            DrawImage(g);
        }

        private void InitalPos(Point pt)
        {
            do
            {
                Random rd = new Random();
                int pIndex = rd.Next(0, lstWalk.Count);

                Pospt = lstWalk[pIndex];
            } while (Pospt == pt);
            this.Location = Pospt;
            System.Threading.Thread.Sleep(50);
        }

        private void MoveTimer_Tick(object sender, EventArgs e)
        {
            EventMoved?.Invoke();
            MonsterMove();
            imgX = imgX == 10 ? 55 : 10;
          
        }
        int len = 5;
        int sumLen = 0;
        public void MonsterMove()
        {
            if (!isMoved)
            {
                BeforeMove();

                if (ListAll != null && ListAll.Count > 0 && ListHas != null && ListHas.Count > 0)
                {
                    Random rd = new Random();
                    var i = rd.Next(0, ListHas.Count);
                    MoveingPt = ListHas[i];
                    direction = ListAll.IndexOf(MoveingPt);
                    isMoved = true;
                }
            }

            if (ListHas != null && ListHas.Count > 0)
            {

                switch (direction)
                {
                    case 0:
                        sumLen += len;
                        if (sumLen >= Width)
                        {
                            isMoved = false;
                            this.Location = MoveingPt;
                            this.Pospt = MoveingPt;
                            sumLen = 0;
                            return;
                        }
                        this.Location = new Point(this.Location.X - len, MoveingPt.Y);
                        this.Pospt = this.Location;


                        break;
                    case 1:

                        sumLen += len;

                        if (sumLen >= Height)
                        {
                            isMoved = false;
                            this.Location = MoveingPt;
                            this.Pospt = MoveingPt;
                            sumLen = 0;
                            return;
                        }
                        this.Location = new Point(MoveingPt.X, this.Location.Y - len);
                        this.Pospt = this.Location;

                        break;
                    case 2:

                        sumLen += len;
                        if (sumLen >= Width)
                        {
                            isMoved = false;
                            this.Location = MoveingPt;
                            this.Pospt = MoveingPt;
                            sumLen = 0;
                            return;
                        }
                        this.Location = new Point(this.Location.X + len, MoveingPt.Y);
                        this.Pospt = this.Location;

                        break;
                    case 3:

                        sumLen += len;
                        if (sumLen >= Height)
                        {
                            isMoved = false;
                            this.Location = MoveingPt;
                            this.Pospt = MoveingPt;
                            sumLen = 0;
                            return;
                        }
                        this.Location = new Point(MoveingPt.X, this.Location.Y + len);
                        this.Pospt = this.Location;
                        break;
                }

            }
        }

        public void Stop()
        {
            this.MoveTimer.Stop();
        }
        public bool IsKillByBoom(List<Point> ptSparks, Boom b)
        {
            int width = Width;
            int height = Height;
            var pt = b.BomPosPt;
            var len = b.Len;
            int i = len / width;

            //List<Point> ptSparks = new List<Point>();

            //for (int j = 1; j <= i; j++)
            //{
            //    var leftPt = new Point(pt.X - j * width, pt.Y);
            //    var upPt = new Point(pt.X, pt.Y - j * height);
            //    var rightPt = new Point(pt.X + j * width, pt.Y);
            //    var downPt = new Point(pt.X, pt.Y + j * height);

            //    ptSparks.Add(leftPt);
            //    ptSparks.Add(upPt);
            //    ptSparks.Add(rightPt);
            //    ptSparks.Add(downPt);

            //}
            ptSparks.Add(b.BomPosPt);
            int w = this.Width;
            int h = this.Height;

            int w2 = w;
            int h2 = h;
            var ptUpLeft = this.Location;
            var ptUpRight = new Point(ptUpLeft.X + w, ptUpLeft.Y);
            var ptRightDown = new Point(ptUpLeft.X + w, ptUpLeft.Y + h);
            var ptLeftDown = new Point(ptUpLeft.X, ptUpLeft.Y + h);

            Point[] ptAll = new Point[4] { ptUpLeft, ptUpRight, ptRightDown, ptLeftDown };


            foreach (var item in ptSparks)
            {
                var ptM = item;

                for (int mm = 0; mm < ptAll.Length; mm++)
                {
                    var temp = ptAll[mm];

                    if (this.Location.X == ptM.X)
                    {
                        if (temp.Y > ptM.Y && temp.Y < ptM.Y + h2)
                        {
                            return true;
                        }

                    }
                    else if (this.Location.Y == ptM.Y)
                    {
                        if (temp.X > ptM.X && temp.X < ptM.X + w2)
                        {
                            return true;
                        }
                    }

                }

            }
            return false;

        }

        private List<Point> BeforeMove()
        {
            Random random = new Random();
            ListAll.Clear();
            ListHas.Clear();

            int x = this.Location.X, y = this.Location.Y;

            var pt = new Point(x, y);
            var leftPt = new Point(pt.X - Width, pt.Y);
            var upPt = new Point(pt.X, pt.Y - Height);
            var rightPt = new Point(pt.X + Width, pt.Y);
            var downPt = new Point(pt.X, pt.Y + Height);


            var pts = new Point[4];

            pts[0] = leftPt;
            pts[1] = upPt;
            pts[2] = rightPt;
            pts[3] = downPt;


            ListAll.AddRange(pts);

            for (int i = 0; i < ListAll.Count; i++)
            {
                if (lstWalk.Contains(ListAll[i]))
                {
                    ListHas.Add(ListAll[i]);
                }
            }
            return ListAll;
        }

        internal void GameEnd()
        {
            this.Stop();

        }
    }
}
