﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Game.BoomerManUI
{
    public class BoomPlayer : Panel
    {
        private int _xPos;
        private int _yPos;
        private int _lifeCount;
        Graphics g = null;
        Image img = Image.FromFile(AppDomain.CurrentDomain.BaseDirectory + "Resource\\Player.png");

        public event Action EventNextLevel = null;
        
        public List<Point> LstExistBoom = null;

        public int XPos
        {
            get { return _xPos; }
            private set {; }
        }

        public Point PtThrough;
        public bool IsHadIn = true;
        public int YPos
        {
            get { return _yPos; }
            private set {; }
        }

        public BoomPlayer(int x, int y)
        {
            LstExistBoom = new List<Point>();
            this._xPos = x;
            this._yPos = y;

            this.Location = new Point(x, y);
            PtThrough = this.Location;
            this._lifeCount = 3;
            Width = 20;
            Height = 20;
            BackColor = System.Drawing.Color.Gold;
        }
        public void GameEnd()
        {
            this._xPos = -40;
            this._yPos = -30;
            this.PtThrough = default;
            this.Location = new Point(_xPos, _yPos);
        }
        public void DoMove(int x, int y)
        {
           
            this._xPos = x;
            this._yPos = y;

            this.Location = new Point(x, y);
        }

        internal bool NextLevel(Point doorPoint)
        {
            if (doorPoint == PtThrough)
            {
                EventNextLevel?.Invoke();
                return true;
            }
            return false;
        }

        public Boom LiveBoom()
        {
            var pt = PtThrough;

            if (LstExistBoom.Contains(pt))
            {
                return null;
            }
            else
            {
                var boom = new Boom(pt.X, pt.Y);
                boom.Name = "boom_" + pt.X + "_" + pt.Y;
                LstExistBoom.Add(pt);
                return boom;
            }
           
        }

        public void RemoveExistBoom(Boom b)
        {
            var pt = b.Location;
            if (LstExistBoom.Contains(pt))
                this.LstExistBoom.Remove(pt);
        }
        int imgX = 10, imgY = 10;
        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);
            g = e.Graphics;
            DrawImage(g);

        }
        private void DrawImage(Graphics g1)
        {
            g1.Clear(Control.DefaultBackColor);
            g1.DrawImage(img, new Rectangle(3, 2, Width, Height), new Rectangle(imgX, imgY, 40, 40), GraphicsUnit.Pixel);


        }

    }
}
