﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using T=System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Game.BoomerManUI
{
    public partial class FrmMain : Form
    {
        public FrmMain()
        {
            InitializeComponent();
            gameManager = new GameManager();
            LstValidKeys.Add(Keys.Space);
            LstValidKeys.Add(Keys.Left);
            LstValidKeys.Add(Keys.Up);
            LstValidKeys.Add(Keys.Right);
            LstValidKeys.Add(Keys.Down);
            MoveTimer = new Timer();
            MoveTimer.Interval = 30;
            MoveTimer.Tick += MoveTimer_Tick;
        }

        private void MoveTimer_Tick(object sender, EventArgs e)
        {
            MoveTimer.Stop();
            int x = player.XPos;
            int y = player.YPos;

            switch (DownKey)
            {
                case Keys.Left:
                    x -= unitX;
                    break;
                case Keys.Up:
                    y -= unitY;
                    break;
                case Keys.Right:
                    x += unitX;
                    break;
                case Keys.Down:
                    y += unitY;
                    break;

            }
           

            if (gameManager.IsCanWalk(DownKey,x, y))
            {
                player.DoMove(x, y);

                if (player.NextLevel(gameManager.DoorPoint))
                {
                    MoveTimer.Stop();
                    IsKeyDown = false;
                    return;
                }
            }

            if (gameManager.PlayerKilledByMonstor())
            {
                GameEnd();
            }
            else
            {
                MoveTimer.Start();
            }
        }

        GameManager gameManager = null;
        BoomPlayer player = null;
        List<Keys> LstValidKeys = new List<Keys>();

        int unitX = 5;
        int unitY = 5;
        Graphics g = null;
        Timer MoveTimer = null;
        private void FrmMain_Load(object sender, EventArgs e)
        {
            this.Width = 820;
            this.Height = 650;
            g = this.CreateGraphics();

            var lstBtn = gameManager.CreateSence();

            foreach (var btn in lstBtn)
            {
                this.Controls.Add(btn);
            }

            player = gameManager.InitPalyerPos();
            player.EventNextLevel += Player_EventNextLevel;
            this.Controls.Add(player);

          var lstMonster=  gameManager.CreateMonstor();

            foreach (var item in lstMonster)
            {
                this.Controls.Add(item);
                item.EventMoved += Item_EventMoved;
                
            }
            var doorpt = gameManager.CreateDoor();

            Panel pDoor = new Panel();
            pDoor.BackColor = Color.YellowGreen;
            pDoor.Width = 40;
            pDoor.Height = 40;
            pDoor.Location = doorpt;
            this.Controls.Add(pDoor);
            
        }

        private void Player_EventNextLevel()
        {

            MoveTimer.Stop();
            IsKeyDown = false;
            MessageBox.Show("下一关");

        }

        private void Item_EventMoved()
        {
            if (gameManager.PlayerKilledByMonstor())
            {
                GameEnd();
            }
        }

        bool IsKeyDown = false;
        public Keys DownKey;
        private void FrmMain_KeyDown(object sender, KeyEventArgs e)
        {
            var key = e.KeyCode;

            if (!LstValidKeys.Contains(key))
            {
                return;
            }
            IsKeyDown = true;MoveTimer.Start();
            int x = player.XPos;
            int y = player.YPos;
            DownKey = key;
           
                switch (key)
                {
                    case Keys.Left:
                        x -= unitX;
                        break;
                    case Keys.Up:
                        y -= unitY;
                        break;
                    case Keys.Right:
                        x += unitX;
                        break;
                    case Keys.Down:
                        y += unitY;
                        break;
                    case Keys.Space:
                        var boom = player.LiveBoom();
                        if (boom != null)
                        {
                            this.Controls.Add(boom);
                            boom.boomBOOMEvent += Boom_boomBOOMEvent;
                        }
                        break;
                }
                //if (key != Keys.Space)
                //{
                //    if (gameManager.IsCanThrough(x, y))
                //    {
                //        player.Move(x, y);
                //    }
                //}

        }

        private void FrmMain_KeyUp(object sender, KeyEventArgs e)
        {
            var key = e.KeyCode;

            if (!LstValidKeys.Contains(key))
            {
                return;
            }
            else
            {
                MoveTimer.Stop();
                IsKeyDown = false;
            }
        }

        private void Boom_boomBOOMEvent(Boom b)
        {

            player.RemoveExistBoom(b);
            this.Controls.Remove(b);

           

            var lstThroughBrikes = gameManager.RemoveThroughBrike(b);
            if (lstThroughBrikes.Count > 0)
            {
                var lstPts = lstThroughBrikes.Select(a => a.Location).ToList();

                this.gameManager.AddWalkPoint(lstPts);

                foreach (var item in lstThroughBrikes)
                {
                    this.Controls.Remove(item);
                }
            }
            List<Point> list= gameManager.ShowSpark(g, b);

            if (gameManager.isBoomPlayer(list, b))
            {

                GameEnd();
            }

            var lst = b.KilledMonstor(list,gameManager.LstMonstor);

            if (lst.Count > 0)
            {
                foreach (var item in lst)
                {
                    this.Controls.Remove(item);
                    gameManager.LstMonstor.Remove(item);
                }
            }

            b.Dispose();
        }

        private void GameEnd()
        {
            this.Controls.Remove(player);
            player.GameEnd();
            gameManager.GameEnd();
            MessageBox.Show("游戏结束");
           
        }
    }
}
