﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Linq.Expressions;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Game.BoomerManUI
{
    public class GameManager
    {
        private const int width = 40;
        private const int height = 40;
        private int MonstorCount = 3;
        private int Rows = 0;
        private int Columns = 0;
        private List<BoomMonstor> _lstMonstor;

        public Point DoorPoint = default;
        
        public List<BoomMonstor> LstMonstor
        {
            get { return _lstMonstor; }
            private set {; }
        }

        public GameManager()
        {
            Rows = 800 / width;
            Columns = 600 / height;
            LstWallBtn = new List<WallBrike>();
            LstWalkPoint = new List<Point>();


        }
        public List<BoomMonstor> CreateMonstor()
        {
            List<BoomMonstor> lst = new List<BoomMonstor>();

            for (int i = 0; i < MonstorCount; i++)
            {
                BoomMonstor m = new BoomMonstor(LstWalkPoint, player.Location);
              
                lst.Add(m);
            }
            _lstMonstor = lst;
            return lst;
        }

        private List<WallBrike> LstWallBtn = null;
        private List<Point> LstWalkPoint = null;
        List<Button> btns = null;


        public Point CreateDoor()
        {
            if (LstWalkPoint != null)
            {
                Random rand = new Random();

                while (true)
                {
                    int index = rand.Next(0, LstWalkPoint.Count);
                    var pt = LstWalkPoint[index];

                    if (null != player)
                    {
                        if (pt != player.Location)
                        {
                            DoorPoint = pt;
                            return pt;
                            
                        }
                    }
                }
            }
            return default;
        }

        public List<Button> CreateSence()
        {
            LstWallBtn.Clear();
            LstWalkPoint.Clear();
            btns = new List<Button>();
            Random random = new Random();
            int rX = 0;
            int rY = 0;
            for (int i = 0; i < Rows; i++)
            {
                for (int j = 0; j < Columns; j++)
                {
                    var pt = new Point(i * width, j * height);
                    var name = "btn_" + i + "_" + j;
                    if (i % 2 == 0)
                    {
                        rX = random.Next(0, 100);

                        if (rX > 80)
                        {
                            Button thBtn = new ThroughBirke();
                            thBtn.Location = pt;
                            thBtn.Name = name;
                            btns.Add(thBtn);
                        }
                        else
                        {
                            LstWalkPoint.Add(pt);
                        }
                    }
                    else
                    {

                        if (j % 2 == 0)
                        {
                            rY = random.Next(0, 100);
                            if (rY > 85)
                            {
                                Button thBtn = new ThroughBirke();
                                thBtn.Location = pt;
                                thBtn.Name = name;
                                btns.Add(thBtn);
                            }
                            else
                            {
                                LstWalkPoint.Add(pt);
                            }
                        }
                        else
                        {
                            Button WallBtn = new WallBrike();
                            WallBtn.Location = pt;
                            WallBtn.Name = name;
                            btns.Add(WallBtn);
                            LstWallBtn.Add((WallBrike)WallBtn);
                        }
                    }
                }
            }

            return btns;
        }

        internal bool IsCanWalk(Keys key, int x, int y)
        {
            player.IsHadIn = false;
            int difX = width - player.Width + 2;

            int difY = height - player.Height + 2;

            var pt = player.PtThrough;

            if (x >= pt.X && x - pt.X <= difX && y - pt.Y <= difY && y >= pt.Y)
            {
                player.IsHadIn = true;
            }


            Point ptGet = default;
            bool canWalk = false;
            switch (key)
            {
                case Keys.Left:
                    ptGet = new Point(pt.X - width, pt.Y);
                    if (LstWalkPoint.Contains(ptGet))
                    {
                        if (x - ptGet.X <= width - player.Width)
                        {
                            player.PtThrough = ptGet;
                            if (player.IsHadIn)
                            {
                                canWalk = true;
                            }
                            player.IsHadIn = false;
                        }
                        else
                        {
                            if (y < pt.Y || (y - pt.Y > height - player.Height))
                            {
                                if (pt.X <= x)
                                {
                                    return true;
                                }

                                var ptBrikeDown = new Point(ptGet.X, ptGet.Y + height);

                                var findBrike = btns.Find(bun => bun.Location == ptBrikeDown);

                                if (findBrike != null)
                                {
                                    return false;
                                }

                                var ptBrikeUp = new Point(ptGet.X, ptGet.Y - height);
                                findBrike = btns.Find(bun => bun.Location == ptBrikeUp);


                                if (findBrike != null)
                                {
                                    return false;
                                }

                            }

                            player.IsHadIn = true;
                        }

                    }
                    else
                    {
                        if (pt.X <= x)
                        {
                            return true;
                        }
                        return player.IsHadIn;
                    }
                    break;
                case Keys.Up:
                    ptGet = new Point(pt.X, pt.Y - height);
                    if (LstWalkPoint.Contains(ptGet))
                    {
                        if (y - ptGet.Y <= height - player.Height)
                        {
                            player.PtThrough = ptGet;
                            canWalk = true;
                            player.IsHadIn = false;
                        }
                        else
                        {

                            if ((x - pt.X < 0) || (x - pt.X > width - player.Width))
                            {
                                if (pt.Y <= y)
                                {
                                    return true;
                                }

                                var ptBrikeRight = new Point(ptGet.X + width, ptGet.Y);

                                var findBrike = btns.Find(bun => bun.Location == ptBrikeRight);

                                if (findBrike != null)
                                {
                                    return false;
                                }

                                var ptBrikeLeft = new Point(ptGet.X - width, ptGet.Y);
                                findBrike = btns.Find(bun => bun.Location == ptBrikeLeft);


                                if (findBrike != null)
                                {
                                    return false;
                                }

                            }

                            player.IsHadIn = true;
                        }

                    }
                    else
                    {
                        if (pt.Y <= y)
                        {
                            return true;
                        }

                        return player.IsHadIn;
                    }

                    break;
                case Keys.Right:
                    ptGet = new Point(pt.X + width, pt.Y);

                    if (LstWalkPoint.Contains(ptGet))
                    {
                        if (ptGet.X <= x)
                        {
                            player.PtThrough = ptGet;
                            canWalk = true;
                            player.IsHadIn = false;
                        }
                        else
                        {
                            if (y<pt.Y||(y-pt.Y>height-player.Height))
                            {
                                if (x - pt.X <= width - player.Width)
                                {
                                    return true;
                                }

                                var ptBrikeDown = new Point(ptGet.X, ptGet.Y+height);

                                var findBrike = btns.Find(bun => bun.Location == ptBrikeDown);

                                if (findBrike != null)
                                {
                                    return false;
                                }

                                var ptBrikeUp = new Point(ptGet.X, ptGet.Y- height);
                                findBrike = btns.Find(bun => bun.Location == ptBrikeUp);


                                if (findBrike != null)
                                {
                                    return false;
                                }

                            }

                            player.IsHadIn = true;
                        }

                    }
                    else
                    {
                        if (x - pt.X <= width - player.Width)
                        {
                            return true;
                        }

                        return player.IsHadIn;
                    }
                    break;
                case Keys.Down:
                    ptGet = new Point(pt.X, pt.Y + height);
                    if (LstWalkPoint.Contains(ptGet))
                    {
                        if (y >= ptGet.Y)
                        {
                            player.PtThrough = ptGet;
                            canWalk = true;
                            player.IsHadIn = false;
                        }
                        else
                        {
                            if ((x - pt.X < 0) || (x - pt.X > width - player.Width))
                            {
                                if (y - pt.Y <= height - player.Height)
                                {
                                    return true;
                                }

                                var ptBrikeRight = new Point(ptGet.X + width, ptGet.Y);

                                var findBrike = btns.Find(bun => bun.Location == ptBrikeRight);

                                if (findBrike != null)
                                {
                                    return false;
                                }

                                var ptBrikeLeft = new Point(ptGet.X - width, ptGet.Y);
                                findBrike = btns.Find(bun => bun.Location == ptBrikeLeft);


                                if (findBrike != null)
                                {
                                    return false;
                                }

                            }
                            player.IsHadIn = true;
                        }

                    }
                    else
                    {
                        if (y - pt.Y <= height - player.Height)
                        {
                            return true;
                        }

                        return player.IsHadIn;
                    }

                    break;
            }

            return player.IsHadIn || canWalk;
        }

        internal void GameEnd()
        {
            foreach (var item in LstMonstor)
            {
                item.GameEnd();
            }

        }

        public List<Button> RemoveThroughBrike(Boom b)
        {
            List<Button> removedButtn = new List<Button>();


            var pt = b.BomPosPt;
            var len = b.Len;
            int i = len / width;

            for (int j = 1; j <= i; j++)
            {
                var leftPt = new Point(pt.X - j * width, pt.Y);
                var upPt = new Point(pt.X, pt.Y - j * height);
                var rightPt = new Point(pt.X + j * width, pt.Y);
                var downPt = new Point(pt.X, pt.Y + j * height);

                var btn = FindBtnByPoint(leftPt);

                if (btn is ThroughBirke)
                {
                    removedButtn.Add(btn);
                    btns.Remove(btn);
                }
                btn = FindBtnByPoint(upPt);

                if (btn is ThroughBirke)
                {
                    removedButtn.Add(btn);
                    btns.Remove(btn);
                }
                btn = FindBtnByPoint(rightPt);

                if (btn is ThroughBirke)
                {
                    removedButtn.Add(btn);
                    btns.Remove(btn);
                }
                btn = FindBtnByPoint(downPt);

                if (btn is ThroughBirke)
                {
                    removedButtn.Add(btn);
                    btns.Remove(btn);
                }

            }

            return removedButtn;
        }

        public  List<Point> ShowSpark(Graphics g, Boom b)
        {
            List<Point> listIgnore = new List<Point>();
            List<Point> listValid = new List<Point>();
            var pt = b.BomPosPt;
            var len = b.Len;
            int i = len / width;
            int left = 0, up = 0, right = 0, down = 0;
            List<RectangleF> lstRecs = new List<RectangleF>();
            Rectangle rec1 = new Rectangle(pt.X, pt.Y, width, height);
            lstRecs.Add(rec1);
            bool leftIsW = false;
            bool upIsW = false;
            bool rightIsW = false;
            bool downisW = false;
            for (int j = 1; j <= i; j++)
            {
                var leftPt = new Point(pt.X - j * width, pt.Y);
                var upPt = new Point(pt.X, pt.Y - j * height);
                var rightPt = new Point(pt.X + j * width, pt.Y);
                var downPt = new Point(pt.X, pt.Y + j * height);
                Button btn = null;
                if (!leftIsW)
                {
                     btn = FindBtnByPoint(leftPt);

                    if (btn == null || btn is ThroughBirke)
                    {
                        Rectangle rec = new Rectangle(pt.X - j * width, pt.Y, width, height);
                        // left -= width;
                        lstRecs.Add(rec);
                        listValid.Add(leftPt);
                    }
                    else
                    {
                        listIgnore.Add(leftPt);
                           leftIsW = true;
                    }
                }
                if (!upIsW)
                {
                    btn = FindBtnByPoint(upPt);

                    if (btn == null || btn is ThroughBirke)
                    {
                        Rectangle rec = new Rectangle(pt.X, pt.Y - j * height, width, height);
                        lstRecs.Add(rec);
                        listValid.Add(upPt);
                        up -= width;
                    }
                    else
                    {
                        listIgnore.Add(upPt);
                        upIsW = true;
                    }
                }

                if (!rightIsW)
                {
                    btn = FindBtnByPoint(rightPt);

                    if (btn == null || btn is ThroughBirke)
                    {
                        Rectangle rec = new Rectangle(pt.X + j * width, pt.Y, width, height);
                        lstRecs.Add(rec);
                        listValid.Add(rightPt);
                        right += width;
                    }
                    else
                    {
                        listIgnore.Add(rightPt);
                        rightIsW = true;
                    }
                }
                if (!downisW)
                {
                    btn = FindBtnByPoint(downPt);

                    if (btn == null || btn is ThroughBirke)
                    {
                        Rectangle rec = new Rectangle(pt.X, pt.Y + j * height, width, height);
                        lstRecs.Add(rec);
                        listValid.Add(downPt);
                        down += width;
                    }
                    else
                    {
                        listIgnore.Add(downPt);
                        downisW = true;
                    }
                }

            }

            g.FillRectangles(Brushes.DarkBlue, lstRecs.ToArray());

            Thread th = new Thread(() =>
              {
                  Thread.Sleep(200);
                  g.Clear(Control.DefaultBackColor);
              });
            th.Start();
            return listValid;

        }
        private Button FindBtnByPoint(Point pt)
        {
            var btn = this.btns.Find(a => a.Location == pt);
            return btn;
        }
        BoomPlayer player = null;
        public BoomPlayer InitPalyerPos()
        {

            if (LstWalkPoint.Count == 0)
            {
                throw new Exception("Init Error");
            }

            Random rd = new Random();

            int pIndex = rd.Next(10, LstWalkPoint.Count);

            var pt = LstWalkPoint[pIndex];

            player = new BoomPlayer(pt.X, pt.Y);

            return player;

        }

        public bool IsCanThrough(int x, int y)
        {
            if (x < 0 || x > 800 || y < 0 || y > 600)
            {
                return false;
            }

            var pt = new Point(x, y);

            if (LstWalkPoint.Contains(pt))
            {
                return true;
            }
            else
            {
                return false;
            }

        }

        public bool isBoomPlayer(List<Point> list, Boom b)
        {
            var pt = b.BomPosPt;
            var len = b.Len;
            int i = len / width;

            if (player.PtThrough == b.BomPosPt)
            {
                return true;
            }

            if (list.Contains(player.PtThrough))
            {
                return true;
            }
            else
            {
                return false;
            }


            for (int j = 1; j <= i; j++)
            {
                var leftPt = new Point(pt.X - j * width, pt.Y);
                var upPt = new Point(pt.X, pt.Y - j * height);
                var rightPt = new Point(pt.X + j * width, pt.Y);
                var downPt = new Point(pt.X, pt.Y + j * height);

                if(list.Contains(leftPt)|| list.Contains(upPt) || list.Contains(rightPt) || list.Contains(downPt))
                {
                    continue;
                }
                if (player.PtThrough == leftPt || player.PtThrough == upPt
                    || player.PtThrough == rightPt || player.PtThrough == downPt)
                {
                    return true;
                }

            }
            return false;

        }

        public void AddWalkPoint(List<Point> pts)
        {
            if (pts != null && pts.Count > 0)
            {
                LstWalkPoint.AddRange(pts);
            }
        }

        public bool PlayerKilledByMonstor()
        {
            int w = player.Width;
            int h = player.Height;
            var ptUpLeft = player.Location;
            var ptUpRight = new Point(ptUpLeft.X + w, ptUpLeft.Y);
            var ptRightDown = new Point(ptUpLeft.X + w, ptUpLeft.Y + h);
            var ptLeftDown = new Point(ptUpLeft.X, ptUpLeft.Y + h);

            Point[] ptAll= new Point[4] { ptUpLeft, ptUpRight, ptRightDown, ptLeftDown };

            
            foreach (var item in LstMonstor)
            {
                var ptM = item.Location;

                for (int i = 0; i < ptAll.Length; i++)
                {
                    var temp = ptAll[i];

                    if (temp.X>ptM.X&&temp.Y>ptM.Y&&temp.X<ptM.X+item.Width&&temp.Y<ptM.Y+item.Height)
                    {
                        return true;
                    }
                }

            }

            return false;
        }

    }
}
